unit UInteractor;

interface
Uses Types,Classes,windows;
{oO0 (nom procedure) 0Oo}

const
  CLASSNAME_FRENCH  ='Dmineur';
  CLASSNAME_ENGLISH ='Minesweeper';
  PROGNAME          ='winmine.exe';

  MSI_SUCCESS		            =1;
  MSI_ERROR		            =127;
  MSI_GAMEWON		            =1;
  MSI_GAMELOST		            =2;
  MSI_GAMEINPROGRESS	            =3;
  MSI_SQUAREHEIGHT		    =16;
  MSI_SQUAREWIDTH		    =16;
  MSI_BOARD_OFFSETX		    =12;
  MSI_BOARD_OFFSETY		    =55;
  MSI_BOARD_OFFSETX_RIGHT	    =8;
  MSI_BOARD_OFFSETY_BOTTOM          =8;
  MSI_MINECOUNTER_OFFSETX	    =17;
  MSI_MINECOUNTER_OFFSETY	    =17;
  MSI_MINECOUNTER_CHARWIDTH =13;
  MSI_SQUARE_BLANK			    =' ';
  MSI_SQUARE_FLAG				    ='!';
  MSI_SQUARE_MINE				    ='*';
  MSI_SQUARE_0				      =0;
  MSI_SQUARE_1			   	    =1;
  MSI_SQUARE_2			        =2;
  MSI_SQUARE_3				      =3;
  MSI_SQUARE_4				      =4;
  MSI_SQUARE_5				      =5;
  MSI_SQUARE_6				      =6;
  MSI_SQUARE_7				      =7;
  MSI_SQUARE_8				      =8;
  MSI_SYMBOLCHECK_OFFSETX	  =9;
  MSI_SYMBOLCHECK_OFFSETY	  =11;
  MSI_SYMBOLCHECK2_OFFSETX  =6;
  MSI_SYMBOLCHECK2_OFFSETY  =6;

Type

TDemineurInteractor = class
public
  fhwnd : HWND ;
  ////////////////////////////////////////////////////////////////////////////////////////
  // Public Member Functions
  ////////////////////////////////////////////////////////////////////////////////////////
  Constructor Create;
  Destructor Destroy; override;
  function GetGoalState(): Byte;
  function GetMinesweeperWindow(): Byte;
  function GetSymbol(column,row : Byte) : Char;
  function GetPlayAreaInfo() : Byte;
  function GetMinesLeft() : SmallInt;
  function GetColumns(): Byte;
  function GetRows() : Byte; 
  function NewGame(): byte;
  function SimulateClick(column,row : byte;rightClick : Boolean = false) : Byte;
  function MoveBehind(parentWindow : HWND) : Byte;
  Function DefineNivel(Niv : integer) : Byte ;
private
  ////////////////////////////////////////////////////////////////////////////////////////
  // Private Member Variables
  // reading pixels from the window's client area.
  ////////////////////////////////////////////////////////////////////////////////////////
  fhdc : HDC ;
  columns, rows : Byte;
  ////////////////////////////////////////////////////////////////////////////////////////
  // Private Member Functions
  ////////////////////////////////////////////////////////////////////////////////////////
  function  DecodeLED(x,y : Smallint) : Smallint;
end;

 Function EnumWindowsProc(hwndCheck : HWND;alParam :  LPARAM ) : Boolean;stdcall; export;

implementation
uses messages,SysUtils;

Function iif(Bool : Boolean;Aval1 : integer;Aval2 : integer) : Integer;
begin
  if Bool then
    Result := Aval1
  else
    Result := Aval2;
end;

Procedure refreshWindow(hwndGen : HWND );
var rcWnd : TRECT ;
begin
  SetFocus(hwndGen);
  GetClientRect(hwndGen,rcWnd);
  InvalidateRect(hwndGen,@rcWnd,FALSE);
  UpdateWindow(hwndGen);
end;

Constructor TDemineurInteractor.Create;
begin
 fhwnd := 0;
 GetMinesweeperWindow;
end;

function TDemineurInteractor.GetRows() : Byte;
begin
  result := iif(fhwnd > 0,rows,MSI_ERROR);
end;
function TDemineurInteractor.GetColumns(): Byte;
begin
  result := iif(fhwnd > 0,columns,MSI_ERROR);
end;
Function TDemineurInteractor.GetGoalState(): Byte ;//unsigned char
var
  tl, mm, bl : COLORREF;
begin
  refreshWindow(fhwnd);
  SetFocus(fhwnd);
  fhdc := GetDC(fhwnd);
  tl := GetPixel(fhdc,integer(8*columns+8), 30);
  mm := GetPixel(fhdc,integer(8*columns+9), 31);
  bl := GetPixel(fhdc,integer(8*columns+8), 32);

  if((tl = CLR_INVALID) or (mm = CLR_INVALID) or (bl = CLR_INVALID)) Then
		Result := MSI_ERROR
  else
  begin
    if( Boolean(tl) and not(Boolean(bl)) and  not(Boolean(mm))) Then
      Result := MSI_GAMELOST
    else if(Boolean(bl) and Boolean(tl) and not(Boolean(mm))) Then
     Result := MSI_GAMEWON
    else
      Result := MSI_GAMEINPROGRESS;
  end;
  releasedc(fhwnd,fhdc);
end;

Function TDemineurInteractor.SimulateClick(column,row : Byte;rightClick: boolean = False) : Byte;
var
  xx, yy : SmallInt;
Begin
  result := MSI_SUCCESS;
  xx := Round(MSI_BOARD_OFFSETX+(column)*MSI_SQUAREWIDTH+MSI_SQUAREWIDTH/2);
  yy := Round(MSI_BOARD_OFFSETY+(row)*MSI_SQUAREWIDTH+MSI_SQUAREWIDTH/2);
  if(rightClick) Then
  begin
    if  not(SendNotifyMessage(fhwnd, WM_RBUTTONDOWN,0, MAKELPARAM(xx,yy))) or
        not(SendNotifyMessage(fhwnd, WM_RBUTTONUP  ,0, MAKELPARAM(xx,yy))) Then
           result := MSI_ERROR;
  end
  else
  begin
    if not(SendNotifyMessage(fhwnd, WM_LBUTTONDOWN, 0, MAKELPARAM(xx,yy))) or
       not(SendNotifyMessage(fhwnd, WM_LBUTTONUP,   0, MAKELPARAM(xx,yy))) Then
         result := MSI_ERROR;
   end;
end;

function WindowsDirectory: String;
const
  dwLength: DWORD = 255;
var
  WindowsDir: PChar;
begin
  GetMem(WindowsDir, dwLength);
  GetWindowsDirectory(WindowsDir, dwLength);
  Result := String(WindowsDir);
  FreeMem(WindowsDir, dwLength);
end;

Function TDemineurInteractor.GetMinesweeperWindow() : Byte;
var
 windir : String;
 StartInfo   : TStartupInfo;
 ProcessInfo : TProcessInformation;
 Fin         : Boolean;
begin
  if (EnumChildWindows(GetDesktopWindow(),@EnumWindowsProc,Cardinal(self))) Then
  begin
    fhdc := 0;
    winDir := WindowsDirectory;
    { Mise  zro de la structure StartInfo }
    FillChar(StartInfo,SizeOf(StartInfo),#0);
    { Seule la taille est renseigne, toutes les autres options }
    { laisses  zro prendront les valeurs par dfaut }
    StartInfo.cb     := SizeOf(StartInfo);
    if not(CreateProcess(Nil,PROGNAME,Nil, Nil,false, 0,nil,Pchar(winDir),StartInfo,ProcessInfo)) Then
    begin
      result := MSI_ERROR;
      exit;
    end;
    CloseHandle(ProcessInfo.hProcess);
    Sleep(100);
    result := GetMinesweeperWindow();
  end
  else
  begin
    MoveBehind(HWND_TOPMOST);
    SetFocus(fhwnd);
    fhdc := GetDC(fhwnd);
    result := MSI_SUCCESS;
  end;
end;

Function EnumWindowsProc(hwndCheck : HWND;alParam : LPARAM ) : Boolean;
var
  Title, ClassName: array[0..255] of char;
  msi    : TDemineurInteractor ;
begin
  Result := True;
  GetWindowText(hwndCheck, Title, 255);
  GetClassName(hwndCheck, ClassName, 255);
  if IsWindowVisible(hwndCheck) then
  begin
    if (Title = CLASSNAME_ENGLISH) or
       (Title = CLASSNAME_French) Then
    begin
      msi := TDemineurInteractor(alParam);
      msi.fhwnd := hwndCheck;
      result   := false;
    end;
  end;
end;

Function TDemineurInteractor.GetSymbol(column,row : byte): Char;
var
  xx, yy : SmallInt;
  color1, color2 : COLORREF;
begin
  xx := column*MSI_SQUAREWIDTH+MSI_BOARD_OFFSETX;
  yy := row*MSI_SQUAREHEIGHT+MSI_BOARD_OFFSETY;
  refreshWindow(fhwnd);
  SetFocus(fhwnd);
  fhdc := GetDC(fhwnd);
  color1 := GetPixel(fhdc,xx+MSI_SYMBOLCHECK_OFFSETX, yy+MSI_SYMBOLCHECK_OFFSETY);
  case (color1)	 of   // on utilise la couleur ,pour determiner le symbol
    $00C0C0C0 : begin // le gris
                  color2 := GetPixel(fhdc, xx, yy);	// recuperle le pixel a la position topleft
                  if(color2 = $00FFFFFF) Then		// si la couleur est blanche ...
                    Result := MSI_SQUARE_BLANK
                  else								   // si la couleur n'est pas blanche ...
                    Result := char(MSI_SQUARE_0);				   // ... le case n'a pas de valeur (0)
                end;
    $00FF0000: Result := char(MSI_SQUARE_1);	 // la couleur est bleu ...        la case a un 1
    $00008000: Result := char(MSI_SQUARE_2);	 // la couleur est vert fonc ...  la case a un 2
    $000000FF: Result := char(MSI_SQUARE_3);	 // la couleur est rouge ...       la case a un 3
    $00800000: Result := char(MSI_SQUARE_4);	 // la couleur est bleu fonc ...  la case a un 4
    $00000080: Result := char(MSI_SQUARE_5);	 // la couleur est rouge fonc ... la case a un 5
    $00808000: Result := char(MSI_SQUARE_6);	 // la couleur est dark cyan ...   la case a un 6
    $00808080: Result := char(MSI_SQUARE_8);	 // la couleur est grise ...       la case a un 8
    $00000000: Begin	// la couleur est noir
            	 color2 := GetPixel(fhdc, xx+MSI_SYMBOLCHECK2_OFFSETX, yy+MSI_SYMBOLCHECK2_OFFSETY);
                 if(color2 = $00FFFFFF) Then		// la couleur est blanche ... la case est  une bombe
                    Result := MSI_SQUARE_MINE
                 else if(color2 = $000000FF) Then	// la couleur est rouge ...   la case a un drapeau
                    Result := MSI_SQUARE_FLAG
                 else
                    Result := Char(MSI_SQUARE_7);		// sinon ...	      la case a un 7
              end;
  else
    Result := Char(MSI_ERROR);					// impossible de determiner la case
  end;
  releasedc(fhwnd,fhdc);
end;

Function TDemineurInteractor.GetPlayAreaInfo() : Byte ;
var
 arect : TRECT;
begin
  refreshWindow(fhwnd);
  SetFocus(fhwnd);

  result := MSI_SUCCESS;
  if not(GetClientRect(fhwnd, arect)) Then
    result := MSI_ERROR;
  if result = MSI_SUCCESS Then
  begin
    columns := Round((arect.right  - (MSI_BOARD_OFFSETX + MSI_BOARD_OFFSETX_RIGHT))  / MSI_SQUAREWIDTH);
    rows    := Round( abs(arect.Bottom - (MSI_BOARD_OFFSETY + MSI_BOARD_OFFSETY_BOTTOM)) / MSI_SQUAREHEIGHT);
  end;
end;

Function TDemineurInteractor.GetMinesLeft() : SmallInt;
var
  mines : SmallInt;
  i : byte;
begin
  mines := 0;
  for i := 0 to 3 do
  begin
    mines := mines +(iif(i=0,100,iif(i=1,10,1))) * DecodeLED(MSI_MINECOUNTER_OFFSETX + MSI_MINECOUNTER_CHARWIDTH*i, MSI_MINECOUNTER_OFFSETY);
  end;
  result := mines;
end;

Function TDemineurInteractor.DecodeLED(x,y : SmallInt): SmallInt;
const
  coords : array[0..6,0..1] of byte = ( (6,2), (2,6), (6,11), (2,16), (6,20),(10,6), (10,16));
var
  i : Byte;
  digitValue : Byte;
begin
  refreshWindow(fhwnd);
  SetFocus(fhwnd);
  fhdc := GetDc(fhwnd);
  digitValue := 0;
  for i:= 0 to pred(6) do
  begin
    digitValue := digitValue SHL 1;
    if(GetPixel(fhdc, x+coords[i,0],y+coords[i,1]) = RGB(255,0,0)) Then
      Inc(digitValue);
   end;
   case(digitValue) of
     111:	Result := 0;
     3:		Result :=1;
     94:	Result :=2;
     87:	Result :=3;
     51:	Result :=4;
     117:	Result :=5;
     125:	Result :=6;
     67:	Result :=7;
     127:	Result := 8;
     119:	Result :=9;
  else
   Result :=0;
  end;
  releasedc(fhwnd,fhdc);
end;


Function TDemineurInteractor.DefineNivel(Niv : integer) : Byte ;
var
 hwndMenu : HMENU ;
 hwndSubMenu : HMENU;
 Id :	 UINT;
begin
  refreshWindow(fhwnd);
  Result := MSI_ERROR;
  hwndMenu := GetMenu(fhwnd);
  if(hwndMenu>0) Then
  begin
    hwndSubMenu := GetSubMenu(hwndMenu, 0);
    if (hwndSubMenu >0) Then
    Begin
    	//prendre l'identifiant du menu associe a "Niveau"  .
      id := GetMenuItemID(hwndSubMenu,Niv);
      if(id <> -1) Then
      begin
        // envoi un mesage a la fenetre pour lui dire que l'on veut une nouvelle action sur le menu .
        if(SendNotifyMessage(fhwnd, WM_COMMAND, MAKEWPARAM(id, 0),hwndSubMenu)) Then
          Result := MSI_SUCCESS;
      end;
    end;
  end;
end;

Function TDemineurInteractor.NewGame() : Byte ;
var
 hwndMenu : HMENU ;
 hwndSubMenu : HMENU;
 Id :	 UINT;
begin
  refreshWindow(fhwnd);
  // recuperer le menu principal de la fenetre .
  Result := MSI_ERROR;
  hwndMenu := GetMenu(fhwnd);
  if(hwndMenu>0) Then
  begin
   // prendre le menu "fichier" du main menu.
    hwndSubMenu := GetSubMenu(hwndMenu, 0);	// "fichier" est le sousmenu 0 (dans l'ordre)
    if (hwndSubMenu >0) Then
    Begin
    	//prendre l'identifiant du menu associe a "Nouveau" .
      id := GetMenuItemID(hwndSubMenu, 0); // "Nouveau" est l'index 0 dans la file d'item (dans l'orde)
      if(id <> -1) Then
      begin
        // envoi un mesage a la fenetre pour lui dire que l'on veut une nouvelle partie .
        if(SendNotifyMessage(fhwnd, WM_COMMAND, MAKEWPARAM(id, 0),hwndSubMenu)) Then
          Result := MSI_SUCCESS;
      end;
    end;
  end;
end;

Function TDemineurInteractor.MoveBehind(parentWindow : HWND) : Byte;//unsigned char
var
 nHorz, nVert : integer;
 ahDC : HDC ;
begin
  ahDC := GetDC (0);
  nHorz := GetDeviceCaps ( ahDC, HORZSIZE);
  nVert := GetDeviceCaps ( ahDC, VERTSIZE);
  ReleaseDC(0,ahDC);
  Result := MSI_ERROR ;
  if(SetWindowPos(fhwnd, parentWindow, nVert,nHorz,0,0 , SWP_SHOWWINDOW)) Then
    Result := MSI_SUCCESS;
end;

Destructor TDemineurInteractor.Destroy;
begin
// DestroyWindow(fhwnd);
// CloseWindow(fhwnd);
 Inherited;
end;

end.


