unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  CommCtrl, Clipbrd,  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Gauges, Spin;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    RGNiveau: TRadioGroup;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button2: TButton;
    Bevel1: TBevel;
    progressControl: TProgressBar;
    log: TListBox;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
    gamesToPlay : integer;
    Function AddLog(Str : String) : Integer;
  public
    { Dclarations publiques }
  end;

Const
  VK_C=67;
  VK_V=86;

var
  Form1: TForm1;


implementation
 uses ShellApi,Types,UAi,Uinteractor;
{$R *.dfm}


Function TForm1.AddLog(Str : String) : Integer;
// Function to add a line to the log, a "listbox".  It can be used like a printf statement.
// E.g. AddLog("There are %d people named %s", myInteger, myName);
// Note that it uses the same function prototype as printf so they could be used interchangably
// using a function pointer.
// See http://www.cplusplus.com/ref/cstdio/sprintf.html for more information
var
  index : integer;
Begin
  if assigned(log)  Then									// if the log (global variable) window (list box) has been created ...
  Begin
    // add the line to the log
    index := SendMessage(log.handle, LB_ADDSTRING, 0,integer(pchar(Str)));
    SendMessage(log.handle, LB_SETCURSEL, index, 0);
    // return the index
    Result := index;
    exit;
  end;
  Result := -1;
  exit;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  msai  : TMinesweeperAI;
  count,i : integer;
  won ,gamesLeft  : SmallInt ;
  lessThan5,lessThan10  : SmallInt ;
  totalTicks : DWORD ;
  startTicks, endTicks : DWORD ;
  slowestGame,
  fastestGame : SmallInt;
  numMoves : SmallInt;	// to keep track of summed number of moves of each type
  numUnitPropagation, numContradiction, numProbability : SmallInt;
  slowest,
  fastest : DWORD;		// to keep track of fastest and slowest games won
  gameResult : Byte ;
begin
  gamesToPlay := SpinEdit1.Value;
  SendMessage(progressControl.Handle,PBM_SETPOS, 0, 0);
  msai := TMinesweeperAI.Create;
  msai.output := AddLog;

  won := 0 ;
  gamesLeft := 1;

  lessThan5  := 0;
  lessThan10 := 0;

  totalTicks := 0;
  startTicks := 0;
  endTicks   := 0;

  slowestGame := 0;
  fastestGame := 0;
  slowest := 0;
  fastest := 65535;

  gameResult := 0 ;
  msai.msi.DefineNivel(RGNiveau.ItemIndex+2);
  SendMessage(progressControl.Handle,PBM_SETRANGE,0,MAKELPARAM(0,gamesToPlay));
  while (gamesLeft <= gamesToPlay) do
  begin
    msai.msi.NewGame();
    msai.msi.GetPlayAreaInfo;
    Sleep(10);
    startTicks := GetTickCount();
    gameResult := msai.SolveBoard(numUnitPropagation,numContradiction,numProbability);
    endTicks := GetTickCount();
    if(gameResult = MSI_GAMEINPROGRESS) Then
    begin
      AddLog('INCONSISTENCY!  Playing many games and AI returned that game was still in progress!');
      break;
    end;
    totalTicks := totalTicks + (endTicks - startTicks);
    numMoves := numUnitPropagation + numContradiction + numProbability;

    if(gameResult = MSI_GAMEWON) Then   // la partie est gagne ...
    begin
        if(msai.verbose[5]) Then
          AddLog(Format('Game %3u was won in %.3f seconds (UP =%.1f%%, C =%.1f%%, P =%.1f%%, moves=%u)',
          [gamesToPlay-gamesLeft, (endTicks - startTicks) / 1000.0, 100.0*numUnitPropagation/numMoves, 100.0*numContradiction/numMoves, 100.0*numProbability/numMoves, numMoves]));
          // determine si c'est le plus rapide ou le plus lent des jeux gagns
      if((endTicks - startTicks) < fastest) Then
      begin
        fastest := endTicks - startTicks; fastestGame := gamesToPlay-gamesLeft;
      end;
      if((endTicks - startTicks) > slowest)	Then
      begin
        slowest := endTicks - startTicks;
        slowestGame := gamesToPlay-gamesLeft;
      end;
       inc(won); // increment notre compteur de jeux gagnant
     end

     else if(gameResult = MSI_GAMELOST) then	// la parti est perdu ...
     begin
       if(numMoves <= 5) then
         inc(lessThan5);
       if(numMoves <= 10) then
         inc(lessThan10);
       if(msai.verbose[5]) then
	 AddLog(Format('Game %3u was lost in %.3f seconds (UP =%.1f%%, C =%.1f%%, P =%.1f%%, moves=%u)',[gamesToPlay-gamesLeft,(endTicks - startTicks) / 1000.0, 100.0*numUnitPropagation/numMoves, 100.0*numContradiction/numMoves, 100.0*numProbability/numMoves, numMoves]));
     end;
     // mise a jour du progress bar
     SendMessage(progressControl.handle, PBM_SETPOS, gamesLeft, 0);
     Label5.Caption := Format('Partie %d/%d',[gamesLeft,gamesToPlay]);
     UpdateWindow(self.Handle);
     inc(gamesLeft);
   end;
   if(msai.verbose[4]) Then
   begin

     AddLog('');
     AddLog(Format('Won %u games out of %u (%f %%)',[won, gamesToPlay, 100.0 *won /gamesToPlay]));
     AddLog(Format('Took %.3f seconds to play %u games (%.3f games/second = %.3f seconds/game)',[totalTicks / 1000.0, gamesToPlay, 1000.0 *gamesToPlay /(totalTicks),(totalTicks)/(1000.0 *gamesToPlay)]));
     if(fastest < 65535) Then
       AddLog(format('Fastest game (%u) was won in %.4f seconds',[fastestGame, fastest / 1000.0]));
     if(slowest <> 0) Then
       AddLog(format('Slowest game (%u) was won in %.4f seconds',[slowestGame, slowest / 1000.0]));
     if(won <> gamesToPlay) Then
     begin
       AddLog(Format('%u of %u (%.1f%%) losses occurred within the first 5 moves ',[lessThan5 , (gamesToPlay-won), 100.0*lessThan5  / (gamesToPlay-won)]));
       AddLog(Format('%u of %u (%.1f%%) losses occurred within the first 10 moves',[lessThan10, (gamesToPlay-won), 100.0*lessThan10 / (gamesToPlay-won)]));
     end;
   end;
  msai.Free;
end;

{
  Mine :=TDemineurInteractor.create;
  count := SpinEdit1.Value;
  for i:=0 to Count do
  begin
    Mine.GetMinesweeperWindow;
    Mine.NewGame;
    Mine.SimulateClick(2,2);

  end;
  Mine.free;
end; }

end.


